wayland::server::xdg_positioner_t(3)

NAME
wayland::server::xdg_positioner_t - child surface positioner

SYNOPSIS

#include <wayland-server-protocol-extra.hpp>

Inherits wayland::server::resource_t.

  Public Member Functions

std::function< void()> & on_destroy ()
destroy the xdg_positioner object
std::function< void(int32_t, int32_t)> & on_set_size ()
set the size of the to-be positioned rectangle
std::function< void(int32_t, int32_t, int32_t, int32_t)> & on_set_anchor_rect ()
set the anchor rectangle within the parent surface
std::function< void(xdg_positioner_anchor)> & on_set_anchor ()
set anchor rectangle anchor
std::function< void(xdg_positioner_gravity)> & on_set_gravity ()
set child surface gravity
std::function< void(xdg_positioner_constraint_adjustment)> & on_set_constraint_adjustment ()
set the adjustment to be done when constrained
std::function< void(int32_t, int32_t)> & on_set_offset ()
set surface position offset
std::function< void()> & on_set_reactive ()
continuously reconstrain the surface
std::function< void(int32_t, int32_t)> & on_set_parent_size ()
std::function< void(uint32_t)> & on_set_parent_configure ()
set parent configure this is a response to
void post_invalid_input (std::string const &msg)
Post error: invalid input provided.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

Detailed Description

child surface positioner

The xdg_positioner provides a collection of rules for the placement of a child surface relative to a parent surface. Rules can be defined to ensure the child surface remains within the visible area's borders, and to specify how the child surface changes its position, such as sliding along an axis, or flipping around a rectangle. These positioner-created rules are constrained by the requirement that a child surface must intersect with or be at least partially adjacent to its parent surface.

See the various requests for details about possible rules.

At the time of the request, the compositor makes a copy of the rules specified by the xdg_positioner. Thus, after the request is complete the xdg_positioner object can be destroyed or reused; further changes to the object will have no effect on previous usages.

For an xdg_positioner object to be considered complete, it must have a non-zero size set by set_size, and a non-zero anchor rectangle set by set_anchor_rect. Passing an incomplete xdg_positioner object when positioning a surface raises an error.

Definition at line 787 of file wayland-server-protocol-extra.hpp.

Member Function Documentation

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  std::function< void()> & xdg_positioner_t::on_destroy ()

destroy the xdg_positioner object Notify the compositor that the xdg_positioner will no longer be used.

Definition at line 1024 of file wayland-server-protocol-extra.cpp.

  std::function< void(xdg_positioner_anchor)> & xdg_positioner_t::on_set_anchor ()

set anchor rectangle anchor

Parameters
    anchor anchor

Defines the anchor point for the anchor rectangle. The specified anchor is used derive an anchor point that the child surface will be positioned relative to. If a corner anchor is set (e.g. 'top_left' or 'bottom_right'), the anchor point will be at the specified corner; otherwise, the derived anchor point will be centered on the specified edge, or in the center of the anchor rectangle if no edge is specified.

Definition at line 1042 of file wayland-server-protocol-extra.cpp.

  std::function< void(int32_t, int32_t, int32_t, int32_t)> & xdg_positioner_t::on_set_anchor_rect ()

set the anchor rectangle within the parent surface

Parameters
    x x position of anchor rectangle
    y y position of anchor rectangle
    width width of anchor rectangle
    height height of anchor rectangle

Specify the anchor rectangle within the parent surface that the child surface will be placed relative to. The rectangle is relative to the window geometry as defined by xdg_surface.set_window_geometry of the parent surface.

When the xdg_positioner object is used to position a child surface, the anchor rectangle may not extend outside the window geometry of the positioned child's parent surface.

If a negative size is set the invalid_input error is raised.

Definition at line 1036 of file wayland-server-protocol-extra.cpp.

  std::function< void(xdg_positioner_constraint_adjustment)> & xdg_positioner_t::on_set_constraint_adjustment ()

set the adjustment to be done when constrained

Parameters
    constraint_adjustment bit mask of constraint adjustments

Specify how the window should be positioned if the originally intended position caused the surface to be constrained, meaning at least partially outside positioning boundaries set by the compositor. The adjustment is set by constructing a bitmask describing the adjustment to be made when the surface is constrained on that axis.

If no bit for one axis is set, the compositor will assume that the child surface should not change its position on that axis when constrained.

If more than one bit for one axis is set, the order of how adjustments are applied is specified in the corresponding adjustment descriptions.

The default adjustment is none.

Definition at line 1054 of file wayland-server-protocol-extra.cpp.

  std::function< void(xdg_positioner_gravity)> & xdg_positioner_t::on_set_gravity ()

set child surface gravity

Parameters
    gravity gravity direction

Defines in what direction a surface should be positioned, relative to the anchor point of the parent surface. If a corner gravity is specified (e.g. 'bottom_right' or 'top_left'), then the child surface will be placed towards the specified gravity; otherwise, the child surface will be centered over the anchor point on any axis that had no gravity specified.

Definition at line 1048 of file wayland-server-protocol-extra.cpp.

  std::function< void(int32_t, int32_t)> & xdg_positioner_t::on_set_offset ()

set surface position offset

Parameters
    x surface position x offset
    y surface position y offset

Specify the surface position offset relative to the position of the anchor on the anchor rectangle and the anchor on the surface. For example if the anchor of the anchor rectangle is at (x, y), the surface has the gravity bottom|right, and the offset is (ox, oy), the calculated surface position will be (x + ox, y + oy). The offset position of the surface is the one used for constraint testing. See set_constraint_adjustment.

An example use case is placing a popup menu on top of a user interface element, while aligning the user interface element of the parent surface with some user interface element placed somewhere in the popup surface.

Definition at line 1060 of file wayland-server-protocol-extra.cpp.

  std::function< void(uint32_t)> & xdg_positioner_t::on_set_parent_configure ()

set parent configure this is a response to

Parameters
    serial serial of parent configure event

Set the serial of an xdg_surface.configure event this positioner will be used in response to. The compositor may use this information together with set_parent_size to determine what future state the popup should be constrained using.

Definition at line 1078 of file wayland-server-protocol-extra.cpp.

  std::function< void(int32_t, int32_t)> & xdg_positioner_t::on_set_parent_size ()

Parameters
    parent_width future window geometry width of parent
    parent_height future window geometry height of parent

Set the parent window geometry the compositor should use when positioning the popup. The compositor may use this information to determine the future state the popup should be constrained using. If this doesn't match the dimension of the parent the popup is eventually positioned against, the behavior is undefined.

The arguments are given in the surface-local coordinate space.

Definition at line 1072 of file wayland-server-protocol-extra.cpp.

  std::function< void()> & xdg_positioner_t::on_set_reactive ()

continuously reconstrain the surface When set reactive, the surface is reconstrained if the conditions used for constraining changed, e.g. the parent window moved.

If the conditions changed and the popup was reconstrained, an xdg_popup.configure event is sent with updated geometry, followed by an xdg_surface.configure event.

Definition at line 1066 of file wayland-server-protocol-extra.cpp.

  std::function< void(int32_t, int32_t)> & xdg_positioner_t::on_set_size ()

set the size of the to-be positioned rectangle

Parameters
    width width of positioned rectangle
    height height of positioned rectangle

Set the size of the surface that is to be positioned with the positioner object. The size is in surface-local coordinates and corresponds to the window geometry. See xdg_surface.set_window_geometry.

If a zero or negative size is set the invalid_input error is raised.

Definition at line 1030 of file wayland-server-protocol-extra.cpp.

  void xdg_positioner_t::post_invalid_input (std::string const & msg)

Post error: invalid input provided.

Definition at line 1084 of file wayland-server-protocol-extra.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post 'not enough memory' error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

Author

Generated automatically by Doxygen for Wayland++ from the source code.